// ---  sizer.c  --- details at www.386xp.com. Thanks to John Findlay for the genuine original
//					 Lcc assembler sample. http://www.johnfindlay.plus.com/lcc-win32/


#include <windows.h>

char WinTitleStr[] = "Test size of parameters";
char WndClassStr[] = "386xp_tWndClass";
char main_mssg_Table[18];	// 3 w = 6! for space and end 0, each 3 w for one address

	DWORD return1;

HWND hwndMain;
HINSTANCE hInst;

	DWORD size_Right;	// DD - see how handing over of values from assembler
	DWORD size_Bottom;	// DD - how hand over to proper c parameters works

#define Naked __declspec(naked)   	// all functions naked

BOOL Naked dummy_msag(void){
	_asm("subl %eax,%eax");
  _asm("ret");
  }

BOOL Naked get_Size_msag(void){
	_asm("pushl %eax");
	_asm("subl %eax,%eax");
	_asm("pop %ax");
	_asm("movl %eax,(%size_Right)");	// here is the result of this small program
	_asm("pop %ax");					// values from ax are written to our DWORDs
	_asm("movl %eax,(%size_Bottom)");	// please verify yourself - e.g. windbg

	_asm("subl %eax,%eax");
  _asm("ret");
}

BOOL Naked destroy_msag(void)
{
	_asm("pushl	$0");
	_asm("call	%PostQuitMessage");
	_asm("movl	$0,%eax");
	_asm("ret");
}
BOOL Naked main_Call_Back(void)
{
	_asm("pushl	%esi");
	_asm("pushl	$_main_mssg_Table");
	_asm("popl	%esi");
	_asm("movl	12(%esp),%ecx");	// +12=msg, +16=wParam
	_asm("cld");

_asm("ori_L3:");
	_asm("leal  4(%esi),%esi");
	_asm("lodsw");
	_asm("or %ax,%ax");
	_asm("jz	ori_L4");
	_asm("cmp	%cx,%ax");
	_asm("jne	ori_L3");
	_asm("movl	20(%esp),%eax");	// lParam
	_asm("call	(%esi)");
	_asm("subl	%eax,%eax");
	_asm("popl	%esi");
	_asm("ret	$16");

_asm("ori_L4:");	// jump here at end of main_mssg_Table
	_asm("popl	%esi");
	_asm("movl  %ecx,8(%esp)"); //_asm("Xchgl 8(Esp),%Ecx");
	_asm("popl (%return1)");
	_asm("call	%DefWindowProcA");
	_asm("pushl (%return1)");
	_asm("ret");

}
BOOL Naked InitApplication(void)
{
	//==========================this inits the _main_mssg_Table
	_asm("pushl	%edi");
	_asm("cld");
	_asm("pushl	$_main_mssg_Table");
	_asm("popl	%edi");
	_asm("mov $0xaaaa,%ax");
	_asm("stosw");
	_asm("mov $0xffff,%ax");
	_asm("stosw");

	_asm("mov $0x0005,%ax");
	_asm("stosw");
	_asm("leal %get_Size_msag,%eax");
	_asm("stosl");

// take this as sample, remember to resize main_mssg_Table
	_asm("mov $0x0002,%ax");
	_asm("stosw");
	_asm("leal %destroy_msag,%eax");
	_asm("stosl");
// following is the end 0 of main_mssg_Table. Remember to resize main_mssg_Table
	_asm("sub %ax,%ax");
	_asm("stosw"); //final 0
	_asm("popl	%edi");
//============================== end of init the _main_mssg_Table
	_asm("pushl  %ebp");
	_asm("movl   %esp,%ebp");
	_asm("subl   $40,%esp");		// make the WNDCLASS struct
	_asm("pushl  $40");				// sizeof(WNDCLASS)
	_asm("pushl  $0");				// all zeros
	_asm("leal  -40(%ebp),%eax");	// effective address of WNDCLASS
	_asm("pushl  %eax");			// pointer to WNDCLASS
	_asm("call   %memset");
	//-----------------------------
	// fill in WNDCLASS struct
	//-----------------------------
	_asm("movl  $11,-40(%ebp)");		// style (CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS)
	_asm("leal  %main_Call_Back,%eax");	//	_asm("leal  %MainWndProc,%eax");
	_asm("movl  %eax,-36(%ebp)");		// address of MainWndProc
	_asm("movl  $0,-32(%ebp)");			// cbClsExtra
	_asm("movl  $0,-28(%ebp)");			// cbWndExtra
	_asm("movl  %hInst,%eax");
	_asm("movl  %eax,-24(%ebp)");		// hInst
	// Icon
//	_asm("pushl $100");					// 100 our icon id
//	_asm("pushl %hInst");
//	_asm("call  %LoadIconA");		// this is taken out, because error, but only in windbg
//	_asm("movl  %eax,-20(%ebp)");
	_asm("movl  $0,-20(%ebp)");
	// Cursor
	_asm("pushl $0x7f01");				// MAKEINTRESOURCE(32513) IDI_APPLICATION
	_asm("pushl $0");
	_asm("call  %LoadCursorA");
	_asm("movl  %eax,-16(%ebp)");
	// Background brush
	_asm("movl  $0x6,-12(%ebp)");		// COLOR_WINDOW+1
	// Name of class
	_asm("movl  $_WndClassStr,%eax");
	_asm("movl  %eax,-4(%ebp)");
	// Menu
	_asm("movl  $0,-8(%ebp)");		// insted of 600 from sample MAKEINTRESOURCE(IDMAINMENU)
	_asm("leal  -40(%ebp),%eax");
	_asm("pushl %eax");

	//-----------------------------
	// register the class
	//-----------------------------
	_asm("call  %RegisterClassA");
	_asm("cmpl 	$0,%eax");
	_asm("je    InitError");
	_asm("movl	$0,%eax");				// return 0
	_asm("jmp	InitExit");

_asm("InitError:");
	_asm("movl	$1,%eax");				// on error return value 1

_asm("InitExit:");						// cleanup the stack
	_asm("movl %ebp,%esp");
	_asm("popl %ebp");
	_asm("ret");
}

HWND Naked CreateWndClassWnd(void)
{
	_asm("pushl	$0");				// lpParam
	_asm("pushl	%hInst");			// hInstance
	_asm("pushl	$0");				// hMenu
	_asm("pushl	$0");				// hWndParent
	_asm("pushl	$159");				// nHeight
	_asm("pushl	$333");		// CW_USEDEFAULT
	_asm("pushl	$22");				// y
	_asm("pushl	$3");		// CW_USEDEFAULT
	_asm("pushl	$0xce0000");		//not 0xcf0000, WS_OVERLAPPEDWINDOW but
									//WS_OVERLAPPEDWINDOW XOR WS_MAXIMIZEBOX
	_asm("pushl	$_WinTitleStr");	// "Winasm" title
	_asm("pushl	$_WndClassStr");	// "WndClass"
	_asm("pushl	$0");				// statt 512= WS_EX_CLIENTEDGE (extended style)
	_asm("call	%CreateWindowExA");
	_asm("ret");
}

int WINAPI Naked WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, INT nCmdShow)
{//	_asm("movl 8(%esp),%hModule_AFDre");
//_asm("movl 4(%esp),%eax");
//_asm("movl %eax,%hModule_AFDre"); // tested, it's the right one
//_asm("movl $0xafafafaf,%eax");
//_asm("movl %eax,4(%esp)");
	_asm("pushl %ebp");
	_asm("movl  %esp,%ebp");
	_asm("subl  $28,%esp");				// make MSG Struct
	_asm("pushl %edi");

	_asm("movl  8(%ebp),%edi");
	_asm("movl  %edi,%hInst");			// store hInstance

	_asm("call  %InitApplication");
	_asm("cmpl  $0,%eax");
	_asm("je    Start");
	_asm("movl  $0,%eax");
	_asm("jmp	WinMainExit");			// failed to create wndclass

_asm("Start:");
	_asm("call  %CreateWndClassWnd");
	_asm("movl  %eax,%hwndMain");		// store hwndMain
	_asm("cmpl  $0,%eax");
	_asm("jne	Continue");
	_asm("movl  $0,%eax");
	_asm("jmp	WinMainExit");			// failed to create window

_asm("Continue:");
	_asm("pushl	$5");					// SW_SHOW
	_asm("pushl	%hwndMain");
	_asm("call	%ShowWindow");
	_asm("jmp	GetMess");

_asm("MainLoop:");
	_asm("leal	-28(%ebp),%edi");		// msg STRUCT
	_asm("pushl	%edi");
	_asm("call	%TranslateMessage");
	_asm("leal	-28(%ebp),%edi");		// msg STRUCT
	_asm("pushl	%edi");
	_asm("call	%DispatchMessageA");

_asm("GetMess:");
	_asm("pushl	$0");
	_asm("pushl	$0");
	_asm("pushl	$0");
	_asm("leal	-28(%ebp),%edi");		// msg STRUCT
	_asm("pushl	%edi");
	_asm("call	%GetMessageA");
	_asm("cmpl	$0,%eax");				// time to quit?
	_asm("jne	MainLoop");

	_asm("movl	-20(%ebp),%eax");		// return wParam from msg struct

_asm("WinMainExit:");
	_asm("popl	%edi");
	_asm("movl  %ebp,%esp");
	_asm("popl  %ebp");
	_asm("ret	$16");					// clean stack
}
