//---------------------------------------------------------
// Doing it the hard way!
//
// John
//---------------------------------------------------------
#include <windows.h>		// various
#include <stdio.h>			// sprintf

//#include "winasmres.h"   not needed

// a few globals
char MessStr[]     = "Hello Windows!";
char WinTitleStr[] = "Winasm";
char WndClassStr[] = "WndClass";

HWND hwndMain;
HINSTANCE hInst;

LRESULT CALLBACK MainWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

#define Naked __declspec(naked)   	// all functions naked

BOOL Naked InitApplication(void)
{
	_asm("pushl  %ebp");
	_asm("movl   %esp,%ebp");
	_asm("subl   $40,%esp");		// make the WNDCLASS struct
	_asm("pushl  $40");				// sizeof(WNDCLASS)
	_asm("pushl  $0");				// all zeros
	_asm("leal  -40(%ebp),%eax");	// effective address of WNDCLASS
	_asm("pushl  %eax");			// pointer to WNDCLASS
	_asm("call   %memset");

	//-----------------------------
	// fill in WNDCLASS struct
	//-----------------------------
	_asm("movl  $11,-40(%ebp)");		// style (CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS)
	_asm("leal  %MainWndProc,%eax");
	_asm("movl  %eax,-36(%ebp)");		// address of MainWndProc
	_asm("movl  $0,-32(%ebp)");			// cbClsExtra
	_asm("movl  $0,-28(%ebp)");			// cbWndExtra
	_asm("movl  %hInst,%eax");
	_asm("movl  %eax,-24(%ebp)");		// hInst
	// Icon
	_asm("pushl $100");					// 100 our icon id
	_asm("pushl %hInst");
	_asm("call  %LoadIconA");
	_asm("movl  %eax,-20(%ebp)");
	// Cursor
	_asm("pushl $0x7f00");				// MAKEINTRESOURCE(32512) IDI_APPLICATION
	_asm("pushl $0");
	_asm("call  %LoadCursorA");
	_asm("movl  %eax,-16(%ebp)");
	// Background brush
	_asm("movl  $0x6,-12(%ebp)");		// COLOR_WINDOW+1
	// Name of class
	_asm("movl  $_WndClassStr,%eax");
	_asm("movl  %eax,-4(%ebp)");
	// Menu
	_asm("movl  $600,-8(%ebp)");		// MAKEINTRESOURCE(IDMAINMENU)
	_asm("leal  -40(%ebp),%eax");
	_asm("pushl %eax");

	//-----------------------------
	// register the class
	//-----------------------------
	_asm("call  %RegisterClassA");
	_asm("cmpl 	$0,%eax");
	_asm("je    InitError");
	_asm("movl	$0,%eax");				// return 0
	_asm("jmp	InitExit");

_asm("InitError:");
	_asm("movl	$1,%eax");				// on error return 1

_asm("InitExit:");						// cleanup the stack
	_asm("movl %ebp,%esp");
	_asm("popl %ebp");
	_asm("ret");
}

HWND Naked CreateWndClassWnd(void)
{
	_asm("pushl	$0");				// lpParam
	_asm("pushl	%hInst");			// hInstance
	_asm("pushl	$0");				// hMenu
	_asm("pushl	$0");				// hWndParent
	_asm("pushl	$0");				// nHeight
	_asm("pushl	$0x80000000");		// CW_USEDEFAULT
	_asm("pushl	$0");				// y
	_asm("pushl	$0x80000000");		// CW_USEDEFAULT
	_asm("pushl	$0xcf0000");		// WS_OVERLAPPEDWINDOW
	_asm("pushl	$_WinTitleStr");	// "Winasm" title
	_asm("pushl	$_WndClassStr");	// "WndClass"
	_asm("pushl	$512");				// WS_EX_CLIENTEDGE (extended style)
	_asm("call	%CreateWindowExA");
	_asm("ret");
}

// these vars are used for the IntMessBox routine
char s[90];
char f[] = "%d";
char t[] = "Value of Int";
void _stdcall Naked IntMessBox(int i)
{
	_asm("pushl	4(%esp)");		// i
	_asm("pushl	$_f");			// format string
	_asm("pushl	$_s");			// string
	_asm("call	%sprintf");
	_asm("addl	$12,%esp");		// cleanup the stack so far
	_asm("pushl	$16");			// MB_ICONHAND
	_asm("pushl	$_t");			// title
	_asm("pushl	$_s");			// string
	_asm("pushl	%hwndMain");	// hwnd
	_asm("call	%MessageBoxA");	// API's clean the stack
	_asm("ret $4");				// clean the stack for the passed int (_stdcall)
}

BOOL _stdcall Naked AboutDlg(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	_asm("pushl	%ebp");
	_asm("movl	%esp,%ebp");
	_asm("pushl	%ebx");
	_asm("pushl	%edi");
	_asm("movl	12(%ebp),%edi");		// msg

	_asm("cmpl  $272,%edi");			// WM_INITDIALOG
	_asm("movl	$1,%eax");				// return 1 for the button focus
	_asm("je    DLD_EXIT");

	_asm("cmpl	$16,%edi");				// WM_CLOSE
	_asm("je	WM_CLOSE_dlg");

	_asm("cmpl	$273,12(%ebp)");		// WM_COMMAND
	_asm("je	WM_COMMAND_dlg");
	_asm("jmp	RET0_dlg");


_asm("WM_CLOSE_dlg:");
	_asm("pushl	$0");
	_asm("pushl	8(%ebp)");				// hDlg
	_asm("call	%EndDialog");
	_asm("movl	$1,%eax");				// return 1
	_asm("jmp	DLD_EXIT");

_asm("WM_COMMAND_dlg:");
	_asm("movzwl 16(%ebp),%edi");		// LOWORD(wParam)
	_asm("movl	 %edi,%ebx");
	_asm("andl	 $0xffff,%ebx");
	_asm("cmpl	 $1,%ebx");
	_asm("jne	 RET0_dlg");			// else fall through to IDOK

_asm("IDOK:");
	_asm("pushl	 $1");
	_asm("pushl	 8(%ebp)");				// hDlg
	_asm("call	 %EndDialog");
	_asm("movl	 $1,%eax");				// return 1
	_asm("jmp	 DLD_EXIT");

_asm("RET0_dlg:");
	_asm("movl	 $0,%eax");

_asm("DLD_EXIT:");
	_asm("popl	 %edi");
	_asm("popl	 %ebx");
	_asm("movl	 %ebp,%esp");
	_asm("popl	 %ebp");
	_asm("ret	 $16");
}

void Naked MainWndProc_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
	_asm("pushl  %ebp");
	_asm("movl   %esp,%ebp");
	_asm("cmpl   $300,12(%ebp)");
	_asm("je     IDM_EXIT");
	_asm("cmpl   $201,12(%ebp)");
	_asm("je     IDM_MESS");
	_asm("cmpl   $400,12(%ebp)");
	_asm("je     IDM_BEEP");
	_asm("cmpl   $500,12(%ebp)");
	_asm("je     IDM_ABOUT");
	_asm("jmp    OnCommandExit");

_asm("IDM_MESS:");
	_asm("pushl  $47");					// a number
	_asm("call   %IntMessBox");
	_asm("jmp    OnCommandExit");

_asm("IDM_BEEP:");
	_asm("pushl  $0x30");				// MB_ICONEXCLAMATION == 0x30
	_asm("call   %MessageBeep");
	_asm("jmp    OnCommandExit");

_asm("IDM_ABOUT:");
	_asm("pushl $0");
	_asm("leal  %AboutDlg,%eax");
	_asm("pushl	%eax");
	_asm("pushl	%hwndMain");
	_asm("pushl	$0xbb8"); 				// MAKEINTRESOURCE(ID_ABOUT)
	_asm("pushl	%hInst");
	_asm("call	%DialogBoxParamA");
	_asm("jmp   OnCommandExit");

_asm("IDM_EXIT:");
	_asm("pushl  $0");
	_asm("pushl  $0");
	_asm("pushl  $16");					// WM_CLOSE
	_asm("pushl  8(%ebp)");				// hwnd
	_asm("call   %PostMessageA");
	_asm("jmp    OnCommandExit");

_asm("OnCommandExit:");
	_asm("movl  %ebp,%esp");
	_asm("popl  %ebp");
	_asm("ret");
}

LRESULT CALLBACK Naked MainWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	_asm("pushl	%ebp");
	_asm("movl	%esp,%ebp");
	_asm("pushl	%esi");
	_asm("pushl	%edi");
	_asm("movl	12(%ebp),%edi");	// msg
	_asm("cmpl	$15,%edi");			// WM_PAINT == 15
	_asm("je	WM_PAINT_wnd");
	_asm("cmpl	$2,%edi");			// WM_DESTROY == 2
	_asm("je	WM_DESTROY_wnd");
	_asm("cmpl  $273,%edi");		// WM_COMMAND == 273
	_asm("je	WM_COMMAND_wnd");
	_asm("jne	DefWindowProc");

_asm("WM_PAINT_wnd:");
	_asm("subl	$80,%esp");			// make room for the PAINTSTRUCT & RECT
	_asm("leal	-64(%ebp),%edi");	// PAINTSTRUCT
	// BeginPaint
	_asm("pushl	%edi");
	_asm("pushl	8(%ebp)");
	_asm("call	%BeginPaint");
	// GetClientRect
	_asm("leal  -80(%ebp),%edi");	// RECT
	_asm("pushl %edi");
	_asm("pushl	8(%ebp)");			// hwnd
	_asm("call  %GetClientRect");
	// DrawTextA
	_asm("pushl	$37");				// DT_VCENTER | DT_CENTER | DT_SINGLELINE
	_asm("leal  -80(%ebp),%edi");
	_asm("pushl %edi");				// RECT
	_asm("pushl	$-1");				// null terminated string
	_asm("pushl $_MessStr");
	_asm("pushl	-64(%ebp)");		// HDC
	_asm("call	%DrawTextA");
	// EndPaint
	_asm("leal	-64(%ebp),%edi");	// PAINTSTRUCT
	_asm("pushl	%edi");
	_asm("pushl	8(%ebp)");			// hwnd
	_asm("call	%EndPaint");
	_asm("addl	$80,%esp");			// restore stack
	_asm("jmp  RET0_wnd");			// break

_asm("WM_COMMAND_wnd:");
	_asm("movl	16(%ebp),%edi");	// wParam
	_asm("movl	%edi,%esi");
	_asm("shrl	$16,%esi");
	_asm("pushl	%esi");				// HIWORD(wParam) codeNotify
	_asm("pushl	20(%ebp)");			// lParam (hwndCtl)
	_asm("andl	$0xffff,%edi");
	_asm("pushl	%edi");				// LOWORD(wParam) wID
	_asm("pushl	8(%ebp)");			// hwnd
	_asm("call	%MainWndProc_OnCommand");
	_asm("addl	$16,%esp");			// clean stack
	_asm("jmp	RET0_wnd");			// break

_asm("WM_DESTROY_wnd:");
	_asm("pushl	$0");
	_asm("call	%PostQuitMessage");
	_asm("jmp	RET0_wnd");			// break

_asm("DefWindowProc:");
	_asm("pushl	20(%ebp)");
	_asm("pushl	16(%ebp)");
	_asm("pushl	12(%ebp)");
	_asm("pushl	8(%ebp)");
	_asm("call	%DefWindowProcA");
	_asm("jmp	MainWndProcExit");

_asm("RET0_wnd:");
	_asm("movl	$0,%eax");

_asm("MainWndProcExit:");
	_asm("popl	%edi");
	_asm("popl	%esi");
	_asm("movl	%ebp,%esp");
	_asm("popl	%ebp");
	_asm("ret	$16");

}

int WINAPI Naked WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, INT nCmdShow)
{
	_asm("pushl %ebp");
	_asm("movl  %esp,%ebp");
	_asm("subl  $28,%esp");				// make MSG Struct
	_asm("pushl %edi");

	_asm("movl  8(%ebp),%edi");
	_asm("movl  %edi,%hInst");			// store hInstance
	_asm("call  %InitApplication");
	_asm("cmpl  $0,%eax");
	_asm("je    Start");
	_asm("movl  $0,%eax");
	_asm("jmp	WinMainExit");			// failed to create wndclass

_asm("Start:");
	_asm("call  %CreateWndClassWnd");
	_asm("movl  %eax,%hwndMain");		// store hwndMain
	_asm("cmpl  $0,%eax");
	_asm("jne	Continue");
	_asm("movl  $0,%eax");
	_asm("jmp	WinMainExit");			// failed to create window

_asm("Continue:");
	_asm("pushl	$5");					// SW_SHOW
	_asm("pushl	%hwndMain");
	_asm("call	%ShowWindow");
	_asm("jmp	GetMess");

_asm("MainLoop:");
	_asm("leal	-28(%ebp),%edi");		// msg STRUCT
	_asm("pushl	%edi");
	_asm("call	%TranslateMessage");
	_asm("leal	-28(%ebp),%edi");		// msg STRUCT
	_asm("pushl	%edi");
	_asm("call	%DispatchMessageA");

_asm("GetMess:");
	_asm("pushl	$0");
	_asm("pushl	$0");
	_asm("pushl	$0");
	_asm("leal	-28(%ebp),%edi");		// msg STRUCT
	_asm("pushl	%edi");
	_asm("call	%GetMessageA");
	_asm("cmpl	$0,%eax");				// time to quit?
	_asm("jne	MainLoop");

	_asm("movl	-20(%ebp),%eax");		// return wParam from msg struct

_asm("WinMainExit:");
	_asm("popl	%edi");
	_asm("movl  %ebp,%esp");
	_asm("popl  %ebp");
	_asm("ret	$16");					// clean stack
}


